---
 Lib/ctypes/test/test_parameters.py |   49 +++++++++++++++++++++++++++++++++++-
 Modules/_ctypes/callproc.c         |   50 ++++++++++++++-----------------------
 2 files changed, 68 insertions(+), 31 deletions(-)

--- a/Modules/_ctypes/callproc.c
+++ b/Modules/_ctypes/callproc.c
@@ -433,54 +433,47 @@ PyCArg_dealloc(PyCArgObject *self)
 static PyObject *
 PyCArg_repr(PyCArgObject *self)
 {
-    char buffer[256];
     switch(self->tag) {
     case 'b':
     case 'B':
-        sprintf(buffer, "<cparam '%c' (%d)>",
+        return PyString_FromFormat("<cparam '%c' (%d)>",
             self->tag, self->value.b);
-        break;
     case 'h':
     case 'H':
-        sprintf(buffer, "<cparam '%c' (%d)>",
+        return PyString_FromFormat("<cparam '%c' (%d)>",
             self->tag, self->value.h);
-        break;
     case 'i':
     case 'I':
-        sprintf(buffer, "<cparam '%c' (%d)>",
+        return PyString_FromFormat("<cparam '%c' (%d)>",
             self->tag, self->value.i);
-        break;
     case 'l':
     case 'L':
-        sprintf(buffer, "<cparam '%c' (%ld)>",
+        return PyString_FromFormat("<cparam '%c' (%ld)>",
             self->tag, self->value.l);
-        break;
 
 #ifdef HAVE_LONG_LONG
     case 'q':
     case 'Q':
-        sprintf(buffer,
-#ifdef MS_WIN32
-            "<cparam '%c' (%I64d)>",
-#else
-            "<cparam '%c' (%qd)>",
-#endif
+        return PyString_FromFormat("<cparam '%c' (%qd)>",
             self->tag, self->value.q);
-        break;
 #endif
     case 'd':
-        sprintf(buffer, "<cparam '%c' (%f)>",
-            self->tag, self->value.d);
-        break;
     case 'f':
-        sprintf(buffer, "<cparam '%c' (%f)>",
-            self->tag, self->value.f);
-        break;
-
+        {
+            PyObject *f = PyFloat_FromDouble((self->tag == 'f') ? self->value.f : self->value.d);
+            if (f == NULL) {
+                return NULL;
+            }
+            // PyObject *result = PyString_FromFormat("<cparam '%c' (%s)>", self->tag, PyObject_Str(f));
+            char buffer[256];
+            sprintf(buffer, "<cparam '%c' (%f)>", self->tag, (self->tag == 'f') ? self->value.f : self->value.d);
+            PyObject *result = PyString_FromString(buffer);
+            Py_DECREF(f);
+            return result;
+        }
     case 'c':
-        sprintf(buffer, "<cparam '%c' (%c)>",
+        return PyString_FromFormat("<cparam '%c' (%c)>",
             self->tag, self->value.c);
-        break;
 
 /* Hm, are these 'z' and 'Z' codes useful at all?
    Shouldn't they be replaced by the functionality of c_string
@@ -489,16 +482,13 @@ PyCArg_repr(PyCArgObject *self)
     case 'z':
     case 'Z':
     case 'P':
-        sprintf(buffer, "<cparam '%c' (%p)>",
+        return PyString_FromFormat("<cparam '%c' (%p)>",
             self->tag, self->value.p);
-        break;
 
     default:
-        sprintf(buffer, "<cparam '%c' at %p>",
+        return PyString_FromFormat("<cparam '%c' at %p>",
             self->tag, self);
-        break;
     }
-    return PyString_FromString(buffer);
 }
 
 static PyMemberDef PyCArgType_members[] = {
--- a/Lib/ctypes/test/test_parameters.py
+++ b/Lib/ctypes/test/test_parameters.py
@@ -1,5 +1,8 @@
+import re
 import unittest, sys
 
+is64bit = sys.maxsize > 2**32
+
 class SimpleTypesTestCase(unittest.TestCase):
 
     def setUp(self):
@@ -181,8 +184,52 @@ class SimpleTypesTestCase(unittest.TestC
         # ArgumentError: argument 1: ValueError: 99
         self.assertRaises(ArgumentError, func, 99)
 
-
+    def test_parameter_repr(self):
+        from ctypes import (
+            c_bool,
+            c_char,
+            c_wchar,
+            c_byte,
+            c_ubyte,
+            c_short,
+            c_ushort,
+            c_int,
+            c_uint,
+            c_long,
+            c_ulong,
+            c_longlong,
+            c_ulonglong,
+            c_float,
+            c_double,
+            c_longdouble,
+            c_char_p,
+            c_wchar_p,
+            c_void_p,
+        )
+        self.assertTrue(re.search(r"^<cparam '\?' at 0x[A-Fa-f0-9]+>$", repr(c_bool.from_param(True))))
+        self.assertEqual(repr(c_char.from_param(chr(97))), "<cparam 'c' (a)>")
+        self.assertTrue(re.search(r"^<cparam 'u' at 0x[A-Fa-f0-9]+>$", repr(c_wchar.from_param('a'))))
+        self.assertEqual(repr(c_byte.from_param(98)), "<cparam 'b' (98)>")
+        self.assertEqual(repr(c_ubyte.from_param(98)), "<cparam 'B' (98)>")
+        self.assertEqual(repr(c_short.from_param(511)), "<cparam 'h' (511)>")
+        self.assertEqual(repr(c_ushort.from_param(511)), "<cparam 'H' (511)>")
+        self.assertTrue(re.search(r"^<cparam '[li]' \(20000\)>$", repr(c_int.from_param(20000))))
+        self.assertTrue(re.search(r"^<cparam '[LI]' \(20000\)>$", repr(c_uint.from_param(20000))))
+        self.assertTrue(re.search(r"^<cparam '[li]' \(20000\)>$", repr(c_long.from_param(20000))))
+        self.assertTrue(re.search(r"^<cparam '[LI]' \(20000\)>$", repr(c_ulong.from_param(20000))))
+        self.assertEqual(repr(c_float.from_param(1.5)), "<cparam 'f' (1.500000)>")
+        self.assertEqual(repr(c_double.from_param(1.5)), "<cparam 'd' (1.500000)>")
+        self.assertTrue(re.search(r"^<cparam ('d' \(1.5\)|'g' at 0x[A-Fa-f0-9]+)>$", repr(c_longdouble.from_param(1.5))))
+        self.assertTrue(re.search("^<cparam 'z' \(0x[A-Fa-f0-9]+\)>$", repr(c_char_p.from_param(b'hihi'))))
+        self.assertTrue(re.search("^<cparam 'Z' \(0x[A-Fa-f0-9]+\)>$", repr(c_wchar_p.from_param('hihi'))))
+        self.assertTrue(re.search(r"^<cparam 'P' \(0x0*12\)>$", repr(c_void_p.from_param(0x12))))
+        if is64bit:
+            self.assertTrue(re.search(r"^<cparam '[liq]' \(20000\)>$", repr(c_longlong.from_param(20000))))
+            self.assertTrue(re.search(r"^<cparam '[LIQ]' \(20000\)>$", repr(c_ulonglong.from_param(20000))))
+            # Python 2.6 just cannot handle arbitrary large float
+            # self.assertEqual(repr(c_double.from_param(1e300)), "<cparam 'd' (1e+300)>")
 ################################################################
 
+
 if __name__ == '__main__':
     unittest.main()
